Attribute VB_Name = "Module1"
' Engine Related variables
Public EngineOn, MoveCounter, Color, ColorX

'shape related vars
Public X1, X2, Y1, Y2, SizePlus, Spiral, ShapeGS

' Temp Vars
Public Tp1, Tp2, Tp3, Tp4, Tp5, Tp6, Tp7, Tp8, Tp9, Tp10

Public Function FirstStart()

'set initial position of spiral
X1 = Int(Rnd * 320)
Y1 = Int(Rnd * 200)
MoveCounter = 1

End Function

Public Function MainEngineLoop()

' do a loop while EngineOn var is true
Do While EngineOn = True
If MoveCounter > 12 Then MoveCounter = 1

' get the color
Call GetColor
' move the spiral
Call MoveShapePos

' if user want the shape to grow and shrink then do so
If ShapeGS = True Then
ShapeSizeGS
x = DoEvents ' this restores use of the system so app doesnt stop responding
Else
' dont do anything
End If

' move the outside of line
Call MoveShapeOutsidePos
' check position and correct
Call PosCheck
'show coords
Form1.Label3 = X1
Form1.Label4 = Y1
' draw  the line
Call DrawShape


MoveCounter = MoveCounter + 1
x = DoEvents ' this restores use of the system so app doesnt stop responding
Loop

End Function
Public Function GetColor()
' add full color ifs, 1 to 16 also

If ColorX = 17 Then
Color = Int(Rnd * 16)
End If

End Function
Public Function DrawShape()
If Spiral = True Then
' draw the spiral.
Form1.Picture1.Line (X1, Y1)-(X2, Y2), QBColor(Color)
Else
' draw the boxes.
Form1.Picture1.Line (X1, Y1)-(X2, Y2), QBColor(Color), BF
End If

End Function

Public Function PosCheck()
If X1 < 0 Then X1 = 0
If Y1 < 0 Then Y1 = 0
If X1 > 320 Then X1 = 320
If Y1 > 200 Then Y1 = 200
End Function

Public Function ShapeSizeGS()
If GSRand = False Then
' if tp2 is out of rand the cycle it
If Tp3 >= 101 Then Tp3 = 1
If Tp2 >= 5 Then Tp2 = 1
Else
'Randomize
Tp2 = Int(Rnd * 4) + 1
End If

' grow and shrink shapes.
If Tp2 = 1 Then
SizePlus = 0
ElseIf Tp2 = 2 Then
SizePlus = 10
ElseIf Tp2 = 3 Then
SizePlus = 20
ElseIf Tp2 = 4 Then
SizePlus = 30
End If
If GSRand = False Then
Tp3 = Tp3 + 1
If Tp3 = 100 Then
Tp2 = Tp2 + 1
Else
End If
Else
End If

End Function

Public Function MoveShapePos()
' set the random seed
Randomize
Tp1 = Int(Rnd * 5)

If Tp1 = 1 Then
' move up
Y1 = Y1 - 2
ElseIf Tp1 = 2 Then
' move down
Y1 = Y1 + 2
ElseIf Tp1 = 3 Then
' move right
X1 = X1 + 2
ElseIf Tp1 = 4 Then
' move left
X1 = X1 - 2
End If


End Function


Public Function MoveShapeOutsidePos()

' move the spiral outside position
If MoveCounter = 1 Then
Y2 = Y1 - (7 + SizePlus)
X2 = X1
ElseIf MoveCounter = 2 Then
Y2 = Y1 - (6 + SizePlus)
X2 = X1 + (4 + SizePlus)
ElseIf MoveCounter = 3 Then
Y2 = Y1 - (3 + SizePlus)
X2 = X1 + (6 + SizePlus)
ElseIf MoveCounter = 4 Then
Y2 = Y1
X2 = X1 + (7 + SizePlus)
ElseIf MoveCounter = 5 Then
Y2 = Y1 + (3 + SizePlus)
X2 = X1 + (6 + SizePlus)
ElseIf MoveCounter = 6 Then
Y2 = Y1 + (6 + SizePlus)
X2 = X1 + (4 + SizePlus)
ElseIf MoveCounter = 7 Then
Y2 = Y1 + (7 + SizePlus)
X2 = X1
ElseIf MoveCounter = 8 Then
Y2 = Y1 + (6 + SizePlus)
X2 = X1 - (4 + SizePlus)
ElseIf MoveCounter = 9 Then
Y2 = Y1 + (3 + SizePlus)
X2 = X1 - (6 + SizePlus)
ElseIf MoveCounter = 10 Then
Y2 = Y1
X2 = X1 - (7 + SizePlus)
ElseIf MoveCounter = 11 Then
Y2 = Y1 - (3 + SizePlus)
X2 = X1 - (6 + SizePlus)
ElseIf MoveCounter = 12 Then
Y2 = Y1 - (6 + SizePlus)
X2 = X1 - (4 + SizePlus)
End If
' end of shape positioning
End Function


